/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.54 Revision 1.73
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2004 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.54 2005/10/22 17:35:39 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.73 2007/04/16 08:13:40 genstef Exp $
4 4
5# Description: This eclass is used to interface with linux-info in such a way 5# Description: This eclass is used to interface with linux-info in such a way
6# to provide the functionality required and initial functions 6# to provide the functionality required and initial functions
7# required to install external modules against a kernel source 7# required to install external modules against a kernel source
8# tree. 8# tree.
9# 9#
10# Maintainer: John Mylchreest <johnm@gentoo.org> 10# Maintainer: John Mylchreest <johnm@gentoo.org>, Stefan Schweizer <genstef@gentoo.org>
11# Copyright 2004 Gentoo Linux 11# Copyright 2004 Gentoo Linux
12# 12#
13# Please direct your bugs to the current eclass maintainer :) 13# Please direct your bugs to the current eclass maintainer :)
14 14
15# A Couple of env vars are available to effect usage of this eclass 15# A Couple of env vars are available to effect usage of this eclass
76# Each entry is a new line. 76# Each entry is a new line.
77# MODULES_${modulename}_DOCS This is a string list which contains 77# MODULES_${modulename}_DOCS This is a string list which contains
78# the full path to any associated 78# the full path to any associated
79# documents for $modulename 79# documents for $modulename
80 80
81# The order of these is important as both of linux-info and eutils contain
82# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils
83# are deprecated in favor of the ones in linux-info.
84# See http://bugs.gentoo.org/show_bug.cgi?id=127506
81 85
82inherit linux-info 86inherit eutils linux-info multilib
83EXPORT_FUNCTIONS pkg_setup pkg_postinst src_install src_compile pkg_postrm 87EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
84 88
85IUSE="" # don't put pcmcia here, rather in the ebuilds that actually support pcmcia 89IUSE="kernel_linux"
86SLOT="0" 90SLOT="0"
87DESCRIPTION="Based on the $ECLASS eclass" 91DESCRIPTION="Based on the $ECLASS eclass"
88RDEPEND="virtual/modutils 92RDEPEND="kernel_linux? ( virtual/modutils )"
89 pcmcia? ( virtual/pcmcia )" 93DEPEND="${RDEPEND}
90DEPEND="virtual/linux-sources
91 sys-apps/sed 94 sys-apps/sed"
92 pcmcia? ( virtual/pcmcia )"
93 95
94# eclass utilities 96# eclass utilities
95# ---------------------------------- 97# ----------------------------------
96 98
97check_vermagic() { 99check_vermagic() {
100 debug-print-function ${FUNCNAME} $*
101
98 local curr_gcc_ver=$(gcc -dumpversion) 102 local curr_gcc_ver=$(gcc -dumpversion)
99 local tmpfile old_chost old_gcc_ver result=0 103 local tmpfile old_chost old_gcc_ver result=0
100 104
101 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit` 105 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit`
102 tmpfile=${tmpfile//*usr/lib} 106 tmpfile=${tmpfile//*usr/lib}
129 ewarn "to match the kernel, or recompile the kernel first." 133 ewarn "to match the kernel, or recompile the kernel first."
130 die "GCC Version Mismatch." 134 die "GCC Version Mismatch."
131 fi 135 fi
132} 136}
133 137
134unpack_pcmcia_sources() {
135 # So while the two eclasses exist side-by-side and also the ebuilds inherit
136 # both we need to check for PCMCIA_SOURCE_DIR, and if we find it, then we
137 # bail out and assume pcmcia.eclass is working on it.
138 [[ -n ${PCMCIA_SOURCE_DIR} ]] && return 1
139
140 if [[ -f "${1}" ]]; then
141 PCMCIA_SOURCE_DIR="${WORKDIR}/pcmcia-cs/"
142
143 ebegin "Decompressing pcmcia-cs sources"
144 mkdir -p ${PCMCIA_SOURCE_DIR}
145 tar -xjf ${1} -C ${PCMCIA_SOURCE_DIR}
146 eend $?
147
148 if [[ -f ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version ]]; then
149 PCMCIA_VERSION=$(cat ${PCMCIA_SOURCE_DIR}/pcmcia-cs-version)
150 einfo "Found pcmcia-cs-${PCMCIA_VERSION}"
151 fi
152 fi
153}
154
155# Dummy function for compatibility.
156pcmcia_configure() { return 0; }
157
158pcmcia_src_unpack() {
159 local pcmcia_tbz="${ROOT}/usr/src/pcmcia-cs/pcmcia-cs-build-env.tbz2"
160
161 # if the kernel has pcmcia support built in, then we just ignore all this.
162 if linux_chkconfig_present PCMCIA; then
163 einfo "Kernel based PCMCIA support has been detected."
164 else
165 if kernel_is 2 4; then
166 unpack_pcmcia_sources ${pcmcia_tbz};
167 else
168 einfo "We have detected that you are running a 2.6 kernel"
169 einfo "but you are not using the built-in PCMCIA support."
170 einfo "We will assume you know what you are doing, but please"
171 einfo "consider using the built in PCMCIA support instead."
172 sleep 10
173
174 unpack_pcmcia_sources ${pcmcia_tbz};
175 fi
176 fi
177}
178
179use_m() { 138use_m() {
139 debug-print-function ${FUNCNAME} $*
140
180 # if we haven't determined the version yet, we need too. 141 # if we haven't determined the version yet, we need too.
181 get_version; 142 get_version;
182 143
183 # if the kernel version is greater than 2.6.6 then we should use 144 # if the kernel version is greater than 2.6.6 then we should use
184 # M= instead of SUBDIRS= 145 # M= instead of SUBDIRS=
185 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 146 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
186 return 0 || return 1 147 return 0 || return 1
187} 148}
188 149
189convert_to_m() { 150convert_to_m() {
151 debug-print-function ${FUNCNAME} $*
152
190 if use_m 153 if use_m
191 then 154 then
192 [ ! -f "${1}" ] && \ 155 [ ! -f "${1}" ] && \
193 die "convert_to_m() requires a filename as an argument" 156 die "convert_to_m() requires a filename as an argument"
194 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS=" 157 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS="
196 eend $? 159 eend $?
197 fi 160 fi
198} 161}
199 162
200update_depmod() { 163update_depmod() {
164 debug-print-function ${FUNCNAME} $*
165
201 # if we haven't determined the version yet, we need too. 166 # if we haven't determined the version yet, we need too.
202 get_version; 167 get_version;
203 168
204 ebegin "Updating module dependencies for ${KV_FULL}" 169 ebegin "Updating module dependencies for ${KV_FULL}"
205 if [ -r ${KV_OUT_DIR}/System.map ] 170 if [ -r ${KV_OUT_DIR}/System.map ]
214 ewarn 179 ewarn
215 fi 180 fi
216} 181}
217 182
218update_modules() { 183update_modules() {
184 debug-print-function ${FUNCNAME} $*
185
186 if [ -x /sbin/update-modules ] && \
187 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
188 ebegin "Updating modules.conf"
189 /sbin/update-modules
190 eend $?
219 if [ -x /sbin/modules-update ] && \ 191 elif [ -x /sbin/modules-update ] && \
220 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 192 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then
221 ebegin "Updating modules.conf" 193 ebegin "Updating modules.conf"
222 /sbin/modules-update 194 /sbin/modules-update
223 eend $? 195 eend $?
224 fi 196 fi
225} 197}
226 198
227move_old_moduledb() { 199move_old_moduledb() {
200 debug-print-function ${FUNCNAME} $*
201
228 local OLDDIR=${ROOT}/usr/share/module-rebuild/ 202 local OLDDIR=${ROOT}/usr/share/module-rebuild/
229 local NEWDIR=${ROOT}/var/lib/module-rebuild/ 203 local NEWDIR=${ROOT}/var/lib/module-rebuild/
230 204
231 if [[ -f ${OLDDIR}/moduledb ]]; then 205 if [[ -f ${OLDDIR}/moduledb ]]; then
232 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR} 206 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR}
236 rmdir ${OLDDIR} 210 rmdir ${OLDDIR}
237 fi 211 fi
238} 212}
239 213
240update_moduledb() { 214update_moduledb() {
215 debug-print-function ${FUNCNAME} $*
216
241 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 217 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
242 move_old_moduledb 218 move_old_moduledb
243 219
244 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then 220 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then
245 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR} 221 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR}
246 touch ${MODULEDB_DIR}/moduledb 222 touch ${MODULEDB_DIR}/moduledb
247 fi 223 fi
224
248 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 225 if ! grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
249 einfo "Adding module to moduledb." 226 einfo "Adding module to moduledb."
250 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb 227 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb
251 fi 228 fi
252} 229}
253 230
254remove_moduledb() { 231remove_moduledb() {
232 debug-print-function ${FUNCNAME} $*
233
255 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 234 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/
256 move_old_moduledb 235 move_old_moduledb
257 236
258 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb) ]]; then 237 if grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then
259 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb." 238 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
260 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${MODULEDB_DIR}/moduledb 239 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb
261 fi 240 fi
262} 241}
263 242
264set_kvobj() { 243set_kvobj() {
244 debug-print-function ${FUNCNAME} $*
245
265 if kernel_is 2 6 246 if kernel_is 2 6
266 then 247 then
267 KV_OBJ="ko" 248 KV_OBJ="ko"
268 else 249 else
269 KV_OBJ="o" 250 KV_OBJ="o"
271 # Do we really need to know this? 252 # Do we really need to know this?
272 # Lets silence it. 253 # Lets silence it.
273 # einfo "Using KV_OBJ=${KV_OBJ}" 254 # einfo "Using KV_OBJ=${KV_OBJ}"
274} 255}
275 256
257get-KERNEL_CC() {
258 debug-print-function ${FUNCNAME} $*
259
260 local kernel_cc
261 if [ -n "${KERNEL_ABI}" ]; then
262 # In future, an arch might want to define CC_$ABI
263 #kernel_cc="$(get_abi_CC)"
264 #[ -z "${kernel_cc}" ] &&
265 kernel_cc="$(tc-getCC $(ABI=${KERNEL_ABI} get_abi_CHOST))"
266 else
267 kernel_cc=$(tc-getCC)
268 fi
269 echo "${kernel_cc}"
270}
271
276generate_modulesd() { 272generate_modulesd() {
273 debug-print-function ${FUNCNAME} $*
274
277 # This function will generate the neccessary modules.d file from the 275 # This function will generate the neccessary modules.d file from the
278 # information contained in the modules exported parms 276 # information contained in the modules exported parms
279 277
280 local currm_path currm currm_t t myIFS myVAR 278 local currm_path currm currm_t t myIFS myVAR
281 local module_docs module_enabled module_aliases \ 279 local module_docs module_enabled module_aliases \
414 eend 0 412 eend 0
415 return 0 413 return 0
416} 414}
417 415
418find_module_params() { 416find_module_params() {
417 debug-print-function ${FUNCNAME} $*
418
419 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 419 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
420 local i=0 y=0 z=0 420 local i=0 y=0 z=0
421 421
422 for((i=0; i<=${#test}; i++)) 422 for((i=0; i<=${#test}; i++))
423 do 423 do
457 457
458# default ebuild functions 458# default ebuild functions
459# -------------------------------- 459# --------------------------------
460 460
461linux-mod_pkg_setup() { 461linux-mod_pkg_setup() {
462 debug-print-function ${FUNCNAME} $*
463
462 linux-info_pkg_setup; 464 linux-info_pkg_setup;
463 check_kernel_built; 465 check_kernel_built;
464 check_modules_supported; 466 strip_modulenames;
467 [[ -n ${MODULE_NAMES} ]] && check_modules_supported
465 set_kvobj; 468 set_kvobj;
469 # Commented out with permission from johnm until a fixed version for arches
470 # who intentionally use different kernel and userland compilers can be
471 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005
466 check_vermagic; 472 #check_vermagic;
467} 473}
468 474
469linux-mod_src_compile() { 475strip_modulenames() {
470 local modulename libdir srcdir objdir i n myARCH="${ARCH}" 476 debug-print-function ${FUNCNAME} $*
471 ARCH="$(tc-arch-kernel)"
472 477
473 BUILD_TARGETS=${BUILD_TARGETS:-clean module} 478 local i
474
475 for i in ${MODULE_IGNORE} 479 for i in ${MODULE_IGNORE}; do
476 do
477 MODULE_NAMES=${MODULE_NAMES//${i}(*} 480 MODULE_NAMES=${MODULE_NAMES//${i}(*}
478 done 481 done
482}
479 483
484linux-mod_src_compile() {
485 debug-print-function ${FUNCNAME} $*
486
487 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}"
488 ARCH="$(tc-arch-kernel)"
489 ABI="${KERNEL_ABI}"
490
491 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
492 strip_modulenames;
480 for i in ${MODULE_NAMES} 493 for i in ${MODULE_NAMES}
481 do 494 do
482 unset libdir srcdir objdir 495 unset libdir srcdir objdir
483 for n in $(find_module_params ${i}) 496 for n in $(find_module_params ${i})
484 do 497 do
496 then 509 then
497 econf ${ECONF_PARAMS} || \ 510 econf ${ECONF_PARAMS} || \
498 die "Unable to run econf ${ECONF_PARAMS}" 511 die "Unable to run econf ${ECONF_PARAMS}"
499 fi 512 fi
500 513
501 emake ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \ 514 emake HOSTCC="$(tc-getBUILD_CC)" CC="$(get-KERNEL_CC)" LDFLAGS="$(get_abi_LDFLAGS)" \
502 || die "Unable to make \
503 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}." 515 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \
516 || die "Unable to make ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}."
504 touch ${srcdir}/.built 517 touch ${srcdir}/.built
505 cd ${OLDPWD} 518 cd ${OLDPWD}
506 fi 519 fi
507 done 520 done
508 521
509 ARCH="${myARCH}" 522 ARCH="${myARCH}"
523 ABI="${myABI}"
510} 524}
511 525
512linux-mod_src_install() { 526linux-mod_src_install() {
527 debug-print-function ${FUNCNAME} $*
528
513 local modulename libdir srcdir objdir i n 529 local modulename libdir srcdir objdir i n
514 530
515 for i in ${MODULE_IGNORE} 531 strip_modulenames;
516 do
517 MODULE_NAMES=${MODULE_NAMES//${i}(*}
518 done
519
520 for i in ${MODULE_NAMES} 532 for i in ${MODULE_NAMES}
521 do 533 do
522 unset libdir srcdir objdir 534 unset libdir srcdir objdir
523 for n in $(find_module_params ${i}) 535 for n in $(find_module_params ${i})
524 do 536 do
527 libdir=${libdir:-misc} 539 libdir=${libdir:-misc}
528 srcdir=${srcdir:-${S}} 540 srcdir=${srcdir:-${S}}
529 objdir=${objdir:-${srcdir}} 541 objdir=${objdir:-${srcdir}}
530 542
531 einfo "Installing ${modulename} module" 543 einfo "Installing ${modulename} module"
532 cd ${objdir} 544 cd ${objdir} || die "${objdir} does not exist"
533 insinto ${ROOT}lib/modules/${KV_FULL}/${libdir} 545 insinto /lib/modules/${KV_FULL}/${libdir}
534 doins ${modulename}.${KV_OBJ} 546 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
535 cd ${OLDPWD} 547 cd ${OLDPWD}
536 548
537 generate_modulesd ${objdir}/${modulename} 549 generate_modulesd ${objdir}/${modulename}
538 done 550 done
539} 551}
540 552
553linux-mod_pkg_preinst() {
554 debug-print-function ${FUNCNAME} $*
555
556 [ -d ${IMAGE}/lib/modules ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
557 [ -d ${IMAGE}/etc/modules.d ] && UPDATE_MODULES=true || UPDATE_MODULES=false
558 [ -d ${IMAGE}/lib/modules ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
559}
560
541linux-mod_pkg_postinst() { 561linux-mod_pkg_postinst() {
542 update_depmod; 562 debug-print-function ${FUNCNAME} $*
543 update_modules; 563
544 update_moduledb; 564 ${UPDATE_DEPMOD} && update_depmod;
565 ${UPDATE_MODULES} && update_modules;
566 ${UPDATE_MODULEDB} && update_moduledb;
545} 567}
546 568
547linux-mod_pkg_postrm() { 569linux-mod_pkg_postrm() {
570 debug-print-function ${FUNCNAME} $*
548 remove_moduledb; 571 remove_moduledb;
549} 572}

Legend:
Removed from v.1.54  
changed lines
  Added in v.1.73

  ViewVC Help
Powered by ViewVC 1.1.20